Signed-off-by: Yinghai Lu <yinghai.lu@amd.com>
Signed-off-by: Uwe Hermann <uwe@hermann-uwe.de>

Index: src/devices/device.c
===================================================================
--- src/devices/device.c.orig
+++ src/devices/device.c
@@ -292,6 +292,13 @@ void compute_allocate_resource(
 		 * no size.  PCI bridge resources are a good example of this.
 		 */
 		/* Propogate the resource alignment to the bridge register  */
+#if 0
+		if(bridge == (&dev_root.resource[0])) {
+			printk_debug("%s ", dev_path(bus->dev));
+			printk_debug("%s ", dev_path(dev));
+			printk_debug("index %d align change %d %d \n", bridge->index, bridge->align, resource->align);
+		}
+#endif
 		if (resource->align > bridge->align) {
 			bridge->align = resource->align;
 		}
Index: src/devices/hypertransport.c
===================================================================
--- src/devices/hypertransport.c.orig
+++ src/devices/hypertransport.c
@@ -279,20 +279,7 @@ static void ht_collapse_early_enumeratio
 		}
 		/* Has the link failed? */
 		if (ctrl & (1 << 4)) {
-			/*
-			 * Either the link has failed, or we have
-			 * a CRC error.
-			 * Sometimes this can happen due to link
-			 * retrain, so lets knock it down and see
-			 * if its transient
-			 */
-			ctrl |= ((1 << 4) | (1 <<8)); // Link fail + Crc
-			pci_write_config16(prev.dev, prev.pos + prev.ctrl_off, ctrl);
-			ctrl = pci_read_config16(prev.dev, prev.pos + prev.ctrl_off);
-			if (ctrl & ((1 << 4) | (1 << 8))) {
-				printk_alert("Detected error on Hypertransport Link\n");
-				return;
-			}
+			return;
 		}
 	} while((ctrl & (1 << 5)) == 0);
 
@@ -359,6 +346,8 @@ unsigned int hypertransport_scan_chain(s
 	struct ht_link prev;
 	device_t last_func = 0;
 	int ht_dev_num = 0;
+	unsigned temp_unitid;
+	unsigned not_use_count;
 
 #if HT_CHAIN_END_UNITID_BASE < HT_CHAIN_UNITID_BASE
         //let't record the device of last ht device, So we can set the Unitid to HT_CHAIN_END_UNITID_BASE
@@ -396,25 +385,12 @@ unsigned int hypertransport_scan_chain(s
 		/* Wait until the link initialization is complete */
 		do {
 			ctrl = pci_read_config16(prev.dev, prev.pos + prev.ctrl_off);
-
-			if (ctrl & (1 << 6))
-				goto end_of_chain;	// End of chain
-
-			if (ctrl & ((1 << 4) | (1 << 8))) {
-				/*
-				 * Either the link has failed, or we have
-				 * a CRC error.
-				 * Sometimes this can happen due to link
-				 * retrain, so lets knock it down and see
-				 * if its transient
-				 */
-				ctrl |= ((1 << 4) | (1 <<8)); // Link fail + Crc
-				pci_write_config16(prev.dev, prev.pos + prev.ctrl_off, ctrl);
-				ctrl = pci_read_config16(prev.dev, prev.pos + prev.ctrl_off);
-				if (ctrl & ((1 << 4) | (1 << 8))) {
-					printk_alert("Detected error on Hypertransport Link\n");
-					goto end_of_chain;
-				}
+			/* Is this the end of the hypertransport chain?
+			 * Has the link failed?
+			 * If so further scanning is pointless.
+			 */
+			if (ctrl & ((1 << 6) | (1 << 4))) {
+				goto end_of_chain;
 			}
 		} while((ctrl & (1 << 5)) == 0);
 		
@@ -449,39 +425,53 @@ unsigned int hypertransport_scan_chain(s
 		if (flags & 0x1f) {
 			break;
 		}
-
 		flags &= ~0x1f; /* mask out base Unit ID */
-                flags |= next_unitid & 0x1f;
+
+		count = (flags >> 5) & 0x1f; /* get unit count */
+		not_use_count = 0;
+		temp_unitid = next_unitid;
+#if HT_CHAIN_END_UNITID_BASE < HT_CHAIN_UNITID_BASE
+		if(offset_unitid) {
+			if((next_unitid+count)>=0x20) {
+		                temp_unitid = HT_CHAIN_END_UNITID_BASE;
+				//still use the old next_unitid
+				not_use_count = 1;
+			}
+
+		} 
+#endif
+
+                flags |= temp_unitid & 0x1f;
                 pci_write_config16(dev, pos + PCI_CAP_FLAGS, flags);
 
 		/* Update the Unitd id in the device structure */
 		static_count = 1;
 		for(func = dev; func; func = func->sibling) {
-			func->path.u.pci.devfn += (next_unitid << 3);
+			func->path.u.pci.devfn += (temp_unitid << 3);
 			static_count = (func->path.u.pci.devfn >> 3) 
 				- (dev->path.u.pci.devfn >> 3) + 1;
 			last_func = func;
 		}
-
 		/* Compute the number of unitids consumed */
-		count = (flags >> 5) & 0x1f; /* get unit count */
 		printk_spew("%s count: %04x static_count: %04x\n", 
 			dev_path(dev), count, static_count);
 		if (count < static_count) {
 			count = static_count;
 		}
+		if(!not_use_count) 
+			next_unitid +=  count;
 
 		/* Update the Unitid of the next device */
-		ht_unitid_base[ht_dev_num] = next_unitid;
+		ht_unitid_base[ht_dev_num] = temp_unitid;
 		ht_dev_num++;
+
 #if HT_CHAIN_END_UNITID_BASE < HT_CHAIN_UNITID_BASE
 		if(offset_unitid) {
-	                real_last_unitid = next_unitid;
         	        real_last_pos = pos;
+			real_last_unitid = temp_unitid;
 			real_last_dev = dev;
 		}
 #endif
-		next_unitid += count;
 
 		/* Setup the hypetransport link */
 		bus->reset_needed |= ht_setup_link(&prev, dev, pos);
@@ -491,7 +481,7 @@ unsigned int hypertransport_scan_chain(s
 			dev->vendor, dev->device, 
 			(dev->enabled? "enabled": "disabled"), next_unitid);
 
-	} while((last_unitid != next_unitid) && (next_unitid <= (max_devfn >> 3)));
+	} while((last_unitid != next_unitid) && (next_unitid <= 0x1f/*(max_devfn >> 3)*/));
  end_of_chain:
 #if OPT_HT_LINK == 1
 	if(bus->reset_needed) {
@@ -503,7 +493,7 @@ unsigned int hypertransport_scan_chain(s
 #endif
 
 #if HT_CHAIN_END_UNITID_BASE < HT_CHAIN_UNITID_BASE
-        if(offset_unitid && (ht_dev_num>0)) {
+        if(offset_unitid && (ht_dev_num>1) && (real_last_unitid != HT_CHAIN_END_UNITID_BASE) ) {
                 uint16_t flags;
                 int i;
 		device_t last_func = 0;
@@ -511,21 +501,23 @@ unsigned int hypertransport_scan_chain(s
                 flags &= ~0x1f;
                 flags |= HT_CHAIN_END_UNITID_BASE & 0x1f;
                 pci_write_config16(real_last_dev, real_last_pos + PCI_CAP_FLAGS, flags);
-
                 for(func = real_last_dev; func; func = func->sibling) {
                         func->path.u.pci.devfn -= ((real_last_unitid - HT_CHAIN_END_UNITID_BASE) << 3);
 			last_func = func;
                 }
-		
 		ht_unitid_base[ht_dev_num-1] = HT_CHAIN_END_UNITID_BASE; // update last one
 		
                 next_unitid = real_last_unitid;
+		
         }
 #endif
 
 	if (next_unitid > 0x1f) {
 		next_unitid = 0x1f;
 	}
+	if( (bus->secondary == 0) && (next_unitid > 0x17)) { 
+		next_unitid = 0x17; // avoid K8 on bus 0
+	}
 
 	/* Die if any leftover Static devices are are found.  
 	 * There's probably a problem in the Config.lb.
@@ -543,7 +535,7 @@ unsigned int hypertransport_scan_chain(s
 	/* Now that nothing is overlapping it is safe to scan the
 	 * children. 
 	 */
-	max = pci_scan_bus(bus, 0x00, (next_unitid << 3)|7, max); 
+	max = pci_scan_bus(bus, 0x00, ((next_unitid-1) << 3)|7, max); 
 	return max; 
 }
 
Index: src/devices/pci_rom.c
===================================================================
--- src/devices/pci_rom.c.orig
+++ src/devices/pci_rom.c
@@ -4,6 +4,21 @@
 #include <device/pci_ids.h>
 #include <device/pci_ops.h>
 
+#if 0
+static void dump_mem(unsigned start, unsigned end)
+{
+        unsigned i;
+        print_debug("dump_mem:");
+        for(i=start;i<end;i++) {
+                if((i & 0xf)==0) {
+                        printk_debug("\n%08x:", i);
+                }
+                printk_debug(" %02x", (unsigned char)*((unsigned char *)i));
+        }
+        print_debug("\n");
+ }
+#endif
+
 struct rom_header * pci_rom_probe(struct device *dev)
 {
 	unsigned long rom_address;
@@ -29,6 +44,8 @@ struct rom_header * pci_rom_probe(struct
 				   rom_address|PCI_ROM_ADDRESS_ENABLE);
 	}
 
+//	dump_mem(rom_address, rom_address+256);
+
 	rom_header = (struct rom_header *)rom_address;
 	printk_spew("PCI Expansion ROM, signature 0x%04x, INIT size 0x%04x, data ptr 0x%04x\n",
 		    le32_to_cpu(rom_header->signature),
@@ -40,6 +57,7 @@ struct rom_header * pci_rom_probe(struct
 	}
 
 	rom_data = (unsigned char *) rom_header + le32_to_cpu(rom_header->data);
+
 	printk_spew("PCI ROM Image, Vendor %04x, Device %04x,\n",
 		    rom_data->vendor, rom_data->device);
 	if (dev->vendor != rom_data->vendor || dev->device != rom_data->device) {
Index: src/devices/pci_device.c
===================================================================
--- src/devices/pci_device.c.orig
+++ src/devices/pci_device.c
@@ -254,7 +254,7 @@ struct resource *pci_get_resource(struct
 	return resource;
 }
 
-static void pci_get_rom_resource(struct device *dev, unsigned long index)
+void pci_get_rom_resource(struct device *dev, unsigned long index)
 {
 	struct resource *resource;
 	unsigned long value;
Index: src/devices/device_util.c
===================================================================
--- src/devices/device_util.c.orig
+++ src/devices/device_util.c
@@ -389,6 +389,31 @@ resource_t resource_end(struct resource 
 	return end;
 }
 
+void normalize_resource(struct resource *resource)
+{
+        /*
+           increase resource->align and resource->size, so the high bits
+                 is the same in the range
+        */
+        unsigned long long base, end, size;
+        unsigned align;
+        base = resource->base;
+        end = resource_end(resource);
+	
+        size = end + 1ULL  - base;
+
+	if(!size) return;
+
+        align = log2(size);
+        if(size > (1ULL<<align)) align++;
+
+	resource->base = align_up(base, align);
+        resource->align = align;
+        resource->gran = align;
+	resource->size = 1ULL<<align;
+
+}
+
 /**
  * @brief Compute the maximum legal value for resource->base
  * @param resource the resource whose maximum is desired
@@ -489,6 +514,7 @@ void search_global_resources(
 		int i;
 		/* Ignore disabled devices */
 		if (!curdev->have_resources) continue;
+//		printk_debug("search_global_resoures: %s curdev=%x  resources=%x\n", dev_path(curdev), curdev, curdev->resources); //yhlu
 		for(i = 0; i < curdev->resources; i++) {
 			struct resource *resource = &curdev->resource[i];
 			/* If it isn't the right kind of resource ignore it */
@@ -499,6 +525,7 @@ void search_global_resources(
 			if (resource->flags & IORESOURCE_SUBTRACTIVE) {
 				continue;
 			}
+//			report_resource_stored(curdev, resource, " search_global_resources"); //yhlu
 			search(gp, curdev, resource);
 		}
 	}
Index: src/include/usbdebug_direct.h
===================================================================
--- /dev/null
+++ src/include/usbdebug_direct.h
@@ -0,0 +1,17 @@
+#ifndef USBDEBUG_DIRECT_H
+#define USBDEBUG_DIRECT_H
+
+struct ehci_debug_info {
+        void *ehci_caps;
+        void *ehci_regs;
+        void *ehci_debug;
+        unsigned devnum;
+        unsigned endpoint_out;
+        unsigned endpoint_in;
+};
+extern int dbgp_bulk_write_x(struct ehci_debug_info *dbg_info, const char *bytes, int size);
+extern int dbgp_bulk_read_x(struct ehci_debug_info *dbg_info, void *data, int size);
+extern void set_ehci_base(unsigned ehci_base);
+extern void set_ehci_debug(unsigned ehci_deug);
+extern unsigned get_ehci_debug(void);
+#endif
Index: src/include/usb_ch9.h
===================================================================
--- /dev/null
+++ src/include/usb_ch9.h
@@ -0,0 +1,83 @@
+#ifndef USB_CH9_H
+#define USB_CH9_H
+
+#define USB_DIR_OUT                     0               /* to device */
+#define USB_DIR_IN                      0x80            /* to host */
+
+/*
+ * USB types, the second of three bRequestType fields
+ */
+#define USB_TYPE_MASK                   (0x03 << 5)
+#define USB_TYPE_STANDARD               (0x00 << 5)
+#define USB_TYPE_CLASS                  (0x01 << 5)
+#define USB_TYPE_VENDOR                 (0x02 << 5)
+#define USB_TYPE_RESERVED               (0x03 << 5)
+/*
+ * USB recipients, the third of three bRequestType fields
+ */
+#define USB_RECIP_MASK                  0x1f
+#define USB_RECIP_DEVICE                0x00
+#define USB_RECIP_INTERFACE             0x01
+#define USB_RECIP_ENDPOINT              0x02
+#define USB_RECIP_OTHER                 0x03
+/* From Wireless USB 1.0 */
+#define USB_RECIP_PORT                  0x04
+#define USB_RECIP_RPIPE                 0x05
+
+/*
+ * Standard requests, for the bRequest field of a SETUP packet.
+ *
+ * These are qualified by the bRequestType field, so that for example
+ * TYPE_CLASS or TYPE_VENDOR specific feature flags could be retrieved
+ * by a GET_STATUS request.
+ */
+#define USB_REQ_GET_STATUS              0x00
+#define USB_REQ_CLEAR_FEATURE           0x01
+#define USB_REQ_SET_FEATURE             0x03
+#define USB_REQ_SET_ADDRESS             0x05
+#define USB_REQ_GET_DESCRIPTOR          0x06
+#define USB_REQ_SET_DESCRIPTOR          0x07
+#define USB_REQ_GET_CONFIGURATION       0x08
+#define USB_REQ_SET_CONFIGURATION       0x09
+#define USB_REQ_GET_INTERFACE           0x0A
+#define USB_REQ_SET_INTERFACE           0x0B
+#define USB_REQ_SYNCH_FRAME             0x0C
+
+#define USB_REQ_SET_ENCRYPTION          0x0D    /* Wireless USB */
+#define USB_REQ_GET_ENCRYPTION          0x0E
+#define USB_REQ_RPIPE_ABORT             0x0E
+#define USB_REQ_SET_HANDSHAKE           0x0F
+#define USB_REQ_RPIPE_RESET             0x0F
+#define USB_REQ_GET_HANDSHAKE           0x10
+#define USB_REQ_SET_CONNECTION          0x11
+#define USB_REQ_SET_SECURITY_DATA       0x12
+#define USB_REQ_GET_SECURITY_DATA       0x13
+#define USB_REQ_SET_WUSB_DATA           0x14
+#define USB_REQ_LOOPBACK_DATA_WRITE     0x15
+#define USB_REQ_LOOPBACK_DATA_READ      0x16
+#define USB_REQ_SET_INTERFACE_DS        0x17
+
+#define USB_DT_DEBUG                    0x0a
+
+#define USB_DEVICE_DEBUG_MODE           6       /* (special devices only) */
+
+//frim usb_ch9.h
+struct usb_ctrlrequest {
+        uint8_t bRequestType;
+        uint8_t bRequest;
+        uint16_t wValue;
+        uint16_t wIndex;
+        uint16_t wLength;
+} __attribute__ ((packed));
+
+struct usb_debug_descriptor {
+        uint8_t  bLength;
+        uint8_t  bDescriptorType;
+
+        /* bulk endpoints with 8 byte maxpacket */
+        uint8_t  bDebugInEndpoint;
+        uint8_t  bDebugOutEndpoint;
+};
+
+#endif
+
Index: src/include/cpu/x86/bist.h
===================================================================
--- src/include/cpu/x86/bist.h.orig
+++ src/include/cpu/x86/bist.h
@@ -4,7 +4,7 @@
 static void report_bist_failure(unsigned long bist)
 {
 	if (bist != 0) {
-#if CONFIG_USE_INIT
+#if CONFIG_USE_PRINTK_IN_CAR
                 printk_emerg("BIST failed: %08x", bist);
 #else
 		print_emerg("BIST failed: ");
Index: src/include/ehci.h
===================================================================
--- /dev/null
+++ src/include/ehci.h
@@ -0,0 +1,132 @@
+#ifndef EHCI_H
+#define EHCI_H
+
+struct ehci_caps {
+        /* these fields are specified as 8 and 16 bit registers,
+         * but some hosts can't perform 8 or 16 bit PCI accesses.
+         */
+        u32             hc_capbase;
+#define HC_LENGTH(p)            (((p)>>00)&0x00ff)      /* bits 7:0 */
+#define HC_VERSION(p)           (((p)>>16)&0xffff)      /* bits 31:16 */
+        u32             hcs_params;     /* HCSPARAMS - offset 0x4 */
+#define HCS_DEBUG_PORT(p)       (((p)>>20)&0xf) /* bits 23:20, debug port? */
+#define HCS_INDICATOR(p)        ((p)&(1 << 16)) /* true: has port indicators */
+#define HCS_N_CC(p)             (((p)>>12)&0xf) /* bits 15:12, #companion HCs */
+#define HCS_N_PCC(p)            (((p)>>8)&0xf)  /* bits 11:8, ports per CC */
+#define HCS_PORTROUTED(p)       ((p)&(1 << 7))  /* true: port routing */
+#define HCS_PPC(p)              ((p)&(1 << 4))  /* true: port power control */
+#define HCS_N_PORTS(p)          (((p)>>0)&0xf)  /* bits 3:0, ports on HC */
+
+        u32             hcc_params;      /* HCCPARAMS - offset 0x8 */
+#define HCC_EXT_CAPS(p)         (((p)>>8)&0xff) /* for pci extended caps */
+#define HCC_ISOC_CACHE(p)       ((p)&(1 << 7))  /* true: can cache isoc frame */
+#define HCC_ISOC_THRES(p)       (((p)>>4)&0x7)  /* bits 6:4, uframes cached */
+#define HCC_CANPARK(p)          ((p)&(1 << 2))  /* true: can park on async qh */
+#define HCC_PGM_FRAMELISTLEN(p) ((p)&(1 << 1))  /* true: periodic_size changes*/
+#define HCC_64BIT_ADDR(p)       ((p)&(1))       /* true: can use 64-bit addr */
+        u8              portroute [8];   /* nibbles for routing - offset 0xC */
+} __attribute__ ((packed));
+
+/* Section 2.3 Host Controller Operational Registers */
+struct ehci_regs {
+
+        /* USBCMD: offset 0x00 */
+        u32             command;
+/* 23:16 is r/w intr rate, in microframes; default "8" == 1/msec */
+#define CMD_PARK        (1<<11)         /* enable "park" on async qh */
+#define CMD_PARK_CNT(c) (((c)>>8)&3)    /* how many transfers to park for */
+#define CMD_LRESET      (1<<7)          /* partial reset (no ports, etc) */
+#define CMD_IAAD        (1<<6)          /* "doorbell" interrupt async advance */
+#define CMD_ASE         (1<<5)          /* async schedule enable */
+#define CMD_PSE         (1<<4)          /* periodic schedule enable */
+/* 3:2 is periodic frame list size */
+#define CMD_RESET       (1<<1)          /* reset HC not bus */
+#define CMD_RUN         (1<<0)          /* start/stop HC */
+
+        /* USBSTS: offset 0x04 */
+        u32             status;
+#define STS_ASS         (1<<15)         /* Async Schedule Status */
+#define STS_PSS         (1<<14)         /* Periodic Schedule Status */
+#define STS_RECL        (1<<13)         /* Reclamation */
+#define STS_HALT        (1<<12)         /* Not running (any reason) */
+/* some bits reserved */
+        /* these STS_* flags are also intr_enable bits (USBINTR) */
+#define STS_IAA         (1<<5)          /* Interrupted on async advance */
+#define STS_FATAL       (1<<4)          /* such as some PCI access errors */
+#define STS_FLR         (1<<3)          /* frame list rolled over */
+#define STS_PCD         (1<<2)          /* port change detect */
+#define STS_ERR         (1<<1)          /* "error" completion (overflow, ...) */
+#define STS_INT         (1<<0)          /* "normal" completion (short, ...) */
+
+        /* USBINTR: offset 0x08 */
+        u32             intr_enable;
+
+        /* FRINDEX: offset 0x0C */
+        u32             frame_index;    /* current microframe number */
+        /* CTRLDSSEGMENT: offset 0x10 */
+        u32             segment;        /* address bits 63:32 if needed */
+        /* PERIODICLISTBASE: offset 0x14 */
+        u32             frame_list;     /* points to periodic list */
+        /* ASYNCLISTADDR: offset 0x18 */
+        u32             async_next;     /* address of next async queue head */
+
+        u32             reserved [9];
+
+        /* CONFIGFLAG: offset 0x40 */
+        u32             configured_flag;
+#define FLAG_CF         (1<<0)          /* true: we'll support "high speed" */
+
+        /* PORTSC: offset 0x44 */
+        u32             port_status [0];        /* up to N_PORTS */
+/* 31:23 reserved */
+#define PORT_WKOC_E     (1<<22)         /* wake on overcurrent (enable) */
+#define PORT_WKDISC_E   (1<<21)         /* wake on disconnect (enable) */
+#define PORT_WKCONN_E   (1<<20)         /* wake on connect (enable) */
+/* 19:16 for port testing */
+#define PORT_LED_OFF    (0<<14)
+#define PORT_LED_AMBER  (1<<14)
+#define PORT_LED_GREEN  (2<<14)
+#define PORT_LED_MASK   (3<<14)
+#define PORT_OWNER      (1<<13)         /* true: companion hc owns this port */
+#define PORT_POWER      (1<<12)         /* true: has power (see PPC) */
+#define PORT_USB11(x) (((x)&(3<<10))==(1<<10))  /* USB 1.1 device */
+/* 11:10 for detecting lowspeed devices (reset vs release ownership) */
+/* 9 reserved */
+#define PORT_RESET      (1<<8)          /* reset port */
+#define PORT_SUSPEND    (1<<7)          /* suspend port */
+#define PORT_RESUME     (1<<6)          /* resume it */
+#define PORT_OCC        (1<<5)          /* over current change */
+#define PORT_OC         (1<<4)          /* over current active */
+#define PORT_PEC        (1<<3)          /* port enable change */
+#define PORT_PE         (1<<2)          /* port enable */
+#define PORT_CSC        (1<<1)          /* connect status change */
+#define PORT_CONNECT    (1<<0)          /* device connected */
+#define PORT_RWC_BITS   (PORT_CSC | PORT_PEC | PORT_OCC)
+} __attribute__ ((packed));
+
+/* Appendix C, Debug port ... intended for use with special "debug devices"
+ * that can help if there's no serial console.  (nonstandard enumeration.)
+ */
+struct ehci_dbg_port {
+        u32     control;
+#define DBGP_OWNER      (1<<30)
+#define DBGP_ENABLED    (1<<28)
+#define DBGP_DONE       (1<<16)
+#define DBGP_INUSE      (1<<10)
+#define DBGP_ERRCODE(x) (((x)>>7)&0x07)
+#       define DBGP_ERR_BAD     1
+#       define DBGP_ERR_SIGNAL  2
+#define DBGP_ERROR      (1<<6)
+#define DBGP_GO         (1<<5)
+#define DBGP_OUT        (1<<4)
+#define DBGP_LEN(x)     (((x)>>0)&0x0f)
+        u32     pids;
+#define DBGP_PID_GET(x)         (((x)>>16)&0xff)
+#define DBGP_PID_SET(data,tok)  (((data)<<8)|(tok))
+        u32     data03;
+        u32     data47;
+        u32     address;
+#define DBGP_EPADDR(dev,ep)     (((dev)<<8)|(ep))
+} __attribute__ ((packed));
+
+#endif
Index: src/include/device/device.h
===================================================================
--- src/include/device/device.h.orig
+++ src/include/device/device.h
@@ -55,7 +55,11 @@ struct bus {
 	unsigned	disable_relaxed_ordering : 1;
 };
 
-#define MAX_RESOURCES 12 
+#if EXT_CONF_SUPPORT == 1
+	#define MAX_RESOURCES 32 
+#else
+	#define MAX_RESOURCES 12 
+#endif
 #define MAX_LINKS    8 
 /*
  * There is one device structure for each slot-number/function-number
Index: src/include/device/resource.h
===================================================================
--- src/include/device/resource.h.orig
+++ src/include/device/resource.h
@@ -87,6 +87,7 @@ extern struct resource *new_resource(str
 extern struct resource *find_resource(struct device * dev, unsigned index);
 extern resource_t resource_end(struct resource *resource);
 extern resource_t resource_max(struct resource *resource);
+extern void normalize_resource(struct resource *resource);
 extern void report_resource_stored(struct device * dev, struct resource *resource, const char *comment);
 
 typedef void (*resource_search_t)(void *gp, struct device *dev, struct resource *res);
Index: src/cpu/amd/car/copy_and_run.c
===================================================================
--- src/cpu/amd/car/copy_and_run.c.orig
+++ src/cpu/amd/car/copy_and_run.c
@@ -5,9 +5,9 @@
 static inline void print_debug_cp_run(const char *strval, uint32_t val)
 {
 #if CONFIG_USE_PRINTK_IN_CAR
-        printk_debug("%s%08x\r\n", strval, val);
+        printk_ram_debug("%s%08x\r\n", strval, val);
 #else
-        print_debug(strval); print_debug_hex32(val); print_debug("\r\n");
+        print_ram_debug(strval); print_ram_debug_hex32(val); print_ram_debug("\r\n");
 #endif
 }
 
@@ -23,7 +23,7 @@ static void copy_and_run(void)
 	uint8_t *src, *dst; 
         unsigned long ilen, olen;
 
-	print_debug("Copying LinuxBIOS to RAM.\r\n");
+	print_ram_debug("Copying LinuxBIOS to ram.\r\n");
 
 #if !CONFIG_COMPRESS 
 	__asm__ volatile (
@@ -55,7 +55,7 @@ static void copy_and_run(void)
 
 	print_debug_cp_run("linxbios_ram.bin   length = ", olen);
 
-	print_debug("Jumping to LinuxBIOS.\r\n");
+	print_ram_debug("Jumping to LinuxBIOS.\r\n");
 
         __asm__ volatile (
                 "xorl %ebp, %ebp\n\t" /* cpu_reset for hardwaremain dummy */
@@ -95,13 +95,10 @@ static void copy_and_run_ap_code_in_car(
 //        print_debug_cp_run("src=",(uint32_t)src);
 //        print_debug_cp_run("dst=",(uint32_t)dst);
 
-//      dump_mem(src, src+0x100);
-
         olen = unrv2b(src, dst, &ilen);
 //        print_debug_cp_run("linxbios_apc.nrv2b length = ", ilen);
 
 #endif
-//      dump_mem(dst, dst+0x100);
 
 //        print_debug_cp_run("linxbios_apc.bin   length = ", olen);
 
Index: src/cpu/amd/car/cache_as_ram.lds
===================================================================
--- src/cpu/amd/car/cache_as_ram.lds.orig
+++ src/cpu/amd/car/cache_as_ram.lds
@@ -1,10 +1,10 @@
 /* 
  * init sections to place code running with cache as ram.
  * 
- * 2004 by Stefan Reinauer <stepan@openbios.org>
  */
 
 SECTIONS {
+
 	.init . : {
 		_init = .;
 		*(.init.text);
Index: src/cpu/amd/car/clear_init_ram.c
===================================================================
--- src/cpu/amd/car/clear_init_ram.c.orig
+++ src/cpu/amd/car/clear_init_ram.c
@@ -1,13 +1,11 @@
 /* by yhlu 6.2005 */
 /* be warned, this file will be used core 0/node 0 only */
-
 static void __attribute__((noinline)) clear_init_ram(void)
 {
 	// gcc 3.4.5 will inline the copy_and_run and clear_init_ram in post_cache_as_ram
 	// will reuse %edi as 0 from clear_memory for copy_and_run part, actually it is increased already
 	// so noline clear_init_ram
         clear_memory(0,  ((CONFIG_LB_MEM_TOPK<<10) - DCACHE_RAM_SIZE));
-
 }
 
 /* be warned, this file will be used by core other than core 0/node 0 or core0/node0 when cpu_reset*/
@@ -15,4 +13,8 @@ static void set_init_ram_access(void)
 {
 	set_var_mtrr(0, 0x00000000, CONFIG_LB_MEM_TOPK << 10, MTRR_TYPE_WRBACK);
 }
+static void set_init_ram_access_wc(void)
+{
+	set_var_mtrr(0, 0x00000000, CONFIG_LB_MEM_TOPK << 10, MTRR_TYPE_WRCOMB);
+}
 
Index: src/cpu/amd/car/post_cache_as_ram.c
===================================================================
--- src/cpu/amd/car/post_cache_as_ram.c.orig
+++ src/cpu/amd/car/post_cache_as_ram.c
@@ -40,9 +40,6 @@ static void post_cache_as_ram(void)
         }
 #endif
 
-	unsigned testx = 0x5a5a5a5a;
-	print_debug_pcar("testx = ", testx);
-
 	/* copy data from cache as ram to 
 		ram need to set CONFIG_LB_MEM_TOPK to 2048 and use var mtrr instead.
 	 */
@@ -53,7 +50,7 @@ static void post_cache_as_ram(void)
 	set_init_ram_access(); /* So we can access RAM from [1M, CONFIG_LB_MEM_TOPK) */
 
 //	dump_mem(DCACHE_RAM_BASE+DCACHE_RAM_SIZE-0x8000, DCACHE_RAM_BASE+DCACHE_RAM_SIZE-0x7c00);
-	print_debug("Copying data from cache to RAM -- switching to use RAM as stack... ");
+	print_debug("Copying data from cache to ram -- switching to use ram as stack... ");
 
 	/* from here don't store more data in CAR */
 #if 0
@@ -63,13 +60,11 @@ static void post_cache_as_ram(void)
 #endif
 
         memcopy((void *)((CONFIG_LB_MEM_TOPK<<10)-DCACHE_RAM_SIZE), (void *)DCACHE_RAM_BASE, DCACHE_RAM_SIZE); //inline
-//        dump_mem((CONFIG_LB_MEM_TOPK<<10) - 0x8000, (CONFIG_LB_MEM_TOPK<<10) - 0x7c00);
-
         __asm__ volatile (
                 /* set new esp */ /* before _RAMBASE */
                 "subl   %0, %%ebp\n\t"
                 "subl   %0, %%esp\n\t"
-                ::"a"( (DCACHE_RAM_BASE + DCACHE_RAM_SIZE)- (CONFIG_LB_MEM_TOPK<<10) )
+                ::"a"( (DCACHE_RAM_BASE + DCACHE_RAM_SIZE) - (CONFIG_LB_MEM_TOPK<<10) )
         ); // We need to push %eax to the stack (CAR) before copy stack and pop it later after copy stack and change esp
 #if 0
         __asm__ volatile (
@@ -79,19 +74,18 @@ static void post_cache_as_ram(void)
 
 
 	/* We can put data to stack again */
-
+	/* use print_ram_debug instead in following stage */
         /* only global variable sysinfo in cache need to be offset */
-        print_debug("Done\r\n");
-        print_debug_pcar("testx = ", testx);
+        print_ram_debug("Done\r\n");
 
-	print_debug("Disabling cache as ram now \r\n");
+	print_ram_debug("Disabling cache as ram now \r\n");
 	disable_cache_as_ram_bsp();  
 
-        print_debug("Clearing initial memory region: ");
+        print_ram_debug("Clearing initial memory region: ");
         clear_init_ram(); //except the range from [(CONFIG_LB_MEM_TOPK<<10) - DCACHE_RAM_SIZE, (CONFIG_LB_MEM_TOPK<<10))
-        print_debug("Done\r\n");
+        print_ram_debug("Done\r\n");
 
-//	dump_mem((CONFIG_LB_MEM_TOPK<<10) - 0x8000, (CONFIG_LB_MEM_TOPK<<10) - 0x7c00);
+//	dump_mem((CONFIG_LB_MEM_TOPK<<10) - 0x1c00, (CONFIG_LB_MEM_TOPK<<10) - 0x1000);
 
 #ifndef MEM_TRAIN_SEQ
 #define MEM_TRAIN_SEQ 0
@@ -108,7 +102,7 @@ static void post_cache_as_ram(void)
         copy_and_run();
         /* We will not return */
 
-        print_debug("should not be here -\r\n");
+        print_ram_debug("should not be here -\r\n");
 
 }
 
Index: src/cpu/amd/model_fxx/Config.lb
===================================================================
--- src/cpu/amd/model_fxx/Config.lb.orig
+++ src/cpu/amd/model_fxx/Config.lb
@@ -17,5 +17,4 @@ dir /cpu/amd/dualcore
 dir /cpu/amd/microcode
 driver model_fxx_init.o
 object apic_timer.o
-object model_fxx_update_microcode.o
-object processor_name.o
+object model_fxx_update_microcode.o
\ No newline at end of file
Index: src/cpu/amd/model_fxx/fidvid.c
===================================================================
--- src/cpu/amd/model_fxx/fidvid.c.orig
+++ src/cpu/amd/model_fxx/fidvid.c
@@ -481,12 +481,13 @@ static void init_fidvid_bsp(unsigned bsp
         if(fid>(10-4)*2) {
                 fid = (10-4)*2; //x10 
         }
-
+#if 0
         if(vid>=0x1f) {
                 vid+= 4; //unit is 12.5mV
         } else {
                 vid+= 2; //unit is 25mV
         }
+#endif
 
 	fv.common_fidvid = (fid<<8) | (vid<<16);
 
Index: src/cpu/amd/model_fxx/model_fxx_init.c
===================================================================
--- src/cpu/amd/model_fxx/model_fxx_init.c.orig
+++ src/cpu/amd/model_fxx/model_fxx_init.c
@@ -546,6 +546,8 @@ static void amd_set_name_string_f(device
 extern void model_fxx_update_microcode(unsigned cpu_deviceid);
 int init_processor_name(void);
 
+static unsigned ehci_debug_addr;
+
 void model_fxx_init(device_t dev)
 {
 	unsigned long i;
@@ -565,11 +567,21 @@ void model_fxx_init(device_t dev)
 	} 
 #endif
 
+#if CONFIG_USBDEBUG_DIRECT
+	if(!ehci_debug_addr) 
+		ehci_debug_addr = get_ehci_debug();
+	set_ehci_debug(0);
+#endif
+
 	/* Turn on caching if we haven't already */
 	x86_enable_cache();
 	amd_setup_mtrrs();
 	x86_mtrr_check();
 
+#if CONFIG_USBDEBUG_DIRECT
+	set_ehci_debug(ehci_debug_addr);
+#endif
+
         /* Update the microcode */
 	model_fxx_update_microcode(dev->device);
 
@@ -589,9 +601,6 @@ void model_fxx_init(device_t dev)
 	msr.lo |= (1 << 0);
 	wrmsr(HWCR_MSR, msr);
 	
-	/* Set the processor name string */
-	init_processor_name();
-	
 	enable_cache();
 
 	/* Enable the local cpu apics */
Index: src/cpu/amd/model_fxx/init_cpus.c
===================================================================
--- src/cpu/amd/model_fxx/init_cpus.c.orig
+++ src/cpu/amd/model_fxx/init_cpus.c
@@ -356,7 +356,6 @@ static unsigned init_cpus(unsigned cpu_i
 		return bsp_apicid;
 }
 
-#if CONFIG_LOGICAL_CPUS == 1
 
 static unsigned is_core0_started(unsigned nodeid)
 {
@@ -383,4 +382,3 @@ static void wait_all_core0_started(void)
 
 }
 
-#endif
Index: src/cpu/x86/32bit/entry32.inc
===================================================================
--- src/cpu/x86/32bit/entry32.inc.orig
+++ src/cpu/x86/32bit/entry32.inc
@@ -19,11 +19,11 @@ gdtptr:
 
 	/* selgdt 0x08, flat code segment */
 	.word	0xffff, 0x0000		
-	.byte	0x00, 0x9b, 0xcf, 0x00	
+	.byte	0x00, 0x9b, 0xcf, 0x00 /* G=1 and 0x0f, So we get 4Gbytes for limit */	
 
 	/* selgdt 0x10,flat data segment */
 	.word	0xffff, 0x0000		
-	.byte	0x00, 0x93, 0xcf, 0x00	
+	.byte	0x00, 0x93, 0xcf, 0x00
 
 gdt_end:
 	
Index: src/cpu/x86/mtrr/earlymtrr.c
===================================================================
--- src/cpu/x86/mtrr/earlymtrr.c.orig
+++ src/cpu/x86/mtrr/earlymtrr.c
@@ -42,6 +42,7 @@ static void set_var_mtrr(
 
 {
 	/* Bit Bit 32-35 of MTRRphysMask should be set to 1 */
+	/* FIXME: It only support 4G less range */
 	msr_t basem, maskm;
 	basem.lo = base | type;
 	basem.hi = 0;
